#!/usr/bin/perl
# Copyright (c) vhffs project and its contributors
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# 1. Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
#2. Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
#3. Neither the name of vhffs nor the names of its contributors 
#   may be used to endorse or promote products derived from this 
#   software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
#"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
#LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
#FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
#COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
#INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
#BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
#LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
#CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.



package Vhffs::Listengine::Panel;

#Vhffs::User written by sod` <dieu AT gunnm DOT org>

#blablabla, yeah yeah yeah
#how to you feel today ? fucking weather today !

use strict;
use POSIX qw(locale_h);
use HTML::Template;
use locale;
use Locale::gettext;


sub create_themes_select
{
    my $vhffs = shift;
    my $themesdir = $vhffs->get_config->get_themesdir;
    my $templatedir = $vhffs->get_config->get_listengine_templatesdir;
    opendir( DIR , $themesdir );
    my @dirs = readdir( DIR );
    closedir( DIR );
   
    my $output = "";
    my $template = new HTML::Template( filename => $templatedir."/themes.tmpl" );
    my $subtemplate;
    my $theme;
    
    foreach $theme ( @dirs )
    {
	next if( $theme =~ /\./ );
	$subtemplate = new HTML::Template( filename => $templatedir."/theme_part.tmpl" );    
	$subtemplate->param( THEME_NAME => $theme );
	$output .= $subtemplate->output;
    }

    $template->param( THEME => $output );
    

    return( $template->output );
}

sub create_lang_select
{
    my $vhffs = shift;
    my $langdir = $vhffs->get_config->get_intldir;
    my $templatedir = $vhffs->get_config->get_listengine_templatesdir;
    opendir( DIR , $langdir );
    my @dirs = readdir( DIR );
    closedir( DIR );
   
    my $output = "";
    my $template = new HTML::Template( filename => $templatedir."/langs.tmpl" );
    my $subtemplate;
    my $lang;
    
    foreach $lang ( @dirs )
    {
	next if( $lang =~ /\./ );
	$subtemplate = new HTML::Template( filename => $templatedir."/lang_part.tmpl" );    
	$subtemplate->param( LANG_NAME => $lang );
	$output .= $subtemplate->output;
    }

    $template->param( LANG => $output );
    

    return( $template->output );
}


sub check_theme
{
    my $theme = shift;
    return "default" if( ! defined $theme );
    return $theme;
}

sub cook_lang
{
        use CGI;
        my $vhffs;
        my $cgi;
        my $cookie;
        my $lang;

        $vhffs = shift;
        $cgi = new CGI;

        if( $cgi->param( "lang" ) )
        {
                $lang = $cgi->param( "lang" );
                $cookie = CGI->cookie(	-name	=>	"lang" ,
				 						-expires => "+1y",
										-value	=>	$lang );
        }
        elsif( CGI->cookie( "lang" ) )
        {
                $lang = CGI->cookie( "lang" );
        }
        else
        {
                $lang = "en_US";
        }
        setlocale(LC_ALL, $lang );
        bindtextdomain("vhffs", $vhffs->get_config->get_intldir);
        textdomain("vhffs");
        return $cookie;
}


1;
